library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity compteur is
  generic (size : integer := 16 );
  port ( reset : in Std_Logic; 
         clk   : in Std_Logic;
	 up    : in Std_Logic;
 	 load  : in Std_Logic;
	 value : in integer range 0 to size-1;
         output: out integer range 0 to size-1) ;
   end compteur;

architecture comportementale of compteur is
   signal count : integer range 0 to size-1;
begin
   synchrone : process (reset,clk) 
   begin
     if reset='1' then 
	count<=0;
     elsif clk'event and clk='1' then
           if load='1' then 
		count<=value;
	   elsif up='1' then 
		count <= count + 1;
	   else 
		count <= count - 1;
	   end if ;
     end if ;
    end process ;
    output <= count;
end comportementale;
  
