library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_arith.ALL;
use IEEE.STD_LOGIC_signed.ALL;

entity compteur is
  port (  reset : in Std_Logic; 
          clk   : in Std_Logic;
	  up    : in Std_Logic;
 	  load  : in Std_Logic;
	  value : in Std_Logic_Vector(3 downto 0);
          output: out Std_Logic_Vector(3 downto 0) );
end compteur;

architecture comportementale of compteur is
   signal count : Std_Logic_Vector(3 downto 0);
begin
   synchrone : process (reset,clk) 
   begin
     if reset='1' then 
	     count<=(others => '0');
     elsif clk'event and clk='1' then
         if load='1' then 
		      count<=value;
	      elsif up='1' then 
		      count <= count + CONV_STD_LOGIC_VECTOR(1,4);
	      else 
		      count <= count - CONV_STD_LOGIC_VECTOR(1,4);
	      end if ;
     end if ;
    end process ;
    output <= count;  
end comportementale;
  
